/*******************************************************************************
*
* University of Western Australia
* Department of Computer Science
* Copyright (c) Australian Wool Corporation / University of Western Australia
*
* SYSTEM :              VIP
* RELEASE:		3
* SUBSYSTEM:            LIB
* MODULE:		misc.c - Miscellaneous functions of general use 		
* REVISION:             3.2
* AUTHOR:               PK
* CREATION DATE:        October 1986
* REVISION DATE:	10/4/93        
*
********************************************************************************
*
* REVISION LOG
*
* REVISION NO:		3.2
* REVISION DATE:	29 Sept 1993
* COMMENT:		Fixed leftjust();
* BY:			CFF
*
* REVISION NO:		3.1
* REVISION DATE:	9 July 1992
* COMMENT:		ANSIfied and SCCS'd
* BY:			CFF
*
*******************************************************************************/

#ifndef lint
static char *sccs_id = "@(#)misc.c	3.2 10/4/93";
#endif

#include <stdio.h>
#include <stdlib.h>
#include <memory.h>
#include "misc.h"
#include "miscfn.h"

/* Function to get line of input and place it into an array of characters
 * line is the array, nchar is the size of the array
 */

void getline(line, nchar)
 char line[];
 int nchar;
{
int i, ch;

for( i = 0; (i < nchar-1) AND ((ch = getchar()) != EOF)
            AND (ch != '\n');  i++)
   line[i] = ch;

line[i] = '\0';

return;
}


/**  Function to left justify a character string *******************/

char *leftjust(line)
 char *line;
{
     int index;
     int i;
     char *templine;

     templine = (char *) malloc(sizeof(char *) * 80);

     index = strspn(line," ");  /* find 1st character that is not blank */

     for (i=0; i<80-index; i++) {
	 templine[i] = line[i+index];
     }

     templine[i] = '\0';

/*
     index = strspn(line," "); */  /* find 1st character that is not blank */
/*
     return(line + index);
*/

     return((char *) templine);
}

/*- Round -----------------------------------------------------------*/

int Round(v)
 double v;
{
    if(v < 0.0) return((int)(v-0.5));
    else return((int)(v+0.5));
}




